<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\StokkapalService;
use App\Http\Services\ItemService;
use App\Http\Validators\StokkapalValidator;
use App\Http\Services\LokasiitemService;

class StokkapalController extends BaseController
{
    protected $baseService;
    protected $validator;
    private $item;
    private $kapal;
    private $lokasiitem;

    /**
     * Stokkapal constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new StokkapalService();
        $this->validator = new StokkapalValidator();
        $this->lokasiitem = new LokasiitemService();
        $this->item = new ItemService();
    }

    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $this->validator->beforeInsert($request->all());
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->store($request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/stokkapal")->with("successMessages", "Data has been created");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function paging(Request $request)
    {
        $this->data["header"] = ["id" => "id"
            , "itemId" => "itemId"
            , "kapalId" => "kapalId"
            , "lokasiId" => "lokasiId"
            , "jumlah" => "jumlah"
            , "satuan" => "satuan"
            , "status" => "status"
        ];
        $this->data["criteria"] = ["id" => "id"
            , "itemId" => "itemId"
            , "kapalId" => "kapalId"
            , "lokasiId" => "lokasiId"
            , "jumlah" => "jumlah"
            , "satuan" => "satuan"
            , "status" => "status"
        ];
        $this->data["ordering"] = [
            "namaItem:asc" => "Kode Item &uarr;"
            , "namaItem:desc" => "Kode Item &darr;"
            , "deskripsi:asc" => "Deskripsi &uarr;"
            , "deskripsi:desc" => "Deskripsi &darr;"
        ];
        $this->data["stokkapals"] = $this->baseService->paging($request);
        return view("modules.stokkapal.stokkapal_index", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit($id)
    {
        $this->data["stokkapal"] = $this->baseService->show($id);
        return view("modules.stokkapal.stokkapal_edit", $this->data);
    }


    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function update(Request $request, $id)
    {
        $this->validator->beforeUpdate($request->all(), $id);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->update($id, $request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/stokkapal")->with("successMessages", "Data has been updated");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create()
    {
        return view("modules.stokkapal.stokkapal_create", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show(Request $request, $id)
    {
        $auth = json_decode($request->session()->get('auth'));
        $this->data["item"] = $this->item->show($id, $auth->kapalId);
        if($this->data["item"]) {
            $this->data["stokkapals"] = $this->baseService->showBasedOnItem($id, $auth);
            return view("modules.stokkapal.stokkapal_show", $this->data);
        } else {
            return redirect()->to("administrator/stokkapal")->with("errMessage", "Data item can not be found.");
        }
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }


}